# Dev Notes

This file is a kind of scratch-pad for a multitude of ideas, that I can't implement yet. They'll be added to, refined or removed over time, so don't get too attached.

## Links and references

https://rogueliketutorials.com/  
https://python-tcod.readthedocs.io/en/latest/  
https://pyinstaller.org/en/stable/  

```bash
#make the virtual environment
python3 -m venv venv

#useful pre-commit hook
lint_results="$(echo "$(grep -Pro '[\t]+$' */*.py)") $(echo "$(grep -Pro 'usable' */*.py)")"
lint_errors=$(echo "$lint_results" | wc -w)
if [ $lint_errors -gt 0 ]; then
	echo "pre-commit lint errors found: $lint_errors"
	echo "$lint_results"
fi
exit $lint_errors
```

#TODO: figure out turn order, potentially with heapq

## Entity Statistics

#NOTE: Combat system is WIP

Visible Attributes, from 3 to 18:
	STR, Melee Weapons (Accuracy & Damage)
	DEX, Range Weapons (Accuracy & Damage)
	CON, Maximum HP
	INT, Draw Spells (Quantity)
	WIS, Hold Spells (Capacity)
	CHA, NPC Influence (alters shop prices)

Other Attributes:
	Levels (derived from XP and a lookup table)
	Maximum HP ((Levels * 5) + (CON / 2))
	Current HP
	Accuracy (from weapon's attribute)
	Evasion (from armor)
	Damage (from weapon's attribute)
	Absorption (from armor)

Weapons:
	damage_roll = base_type ("2d6") + this_instance ("+2")
	accuracy = base_type ("+0") + this_instance ("+0")

Armor:
	evasion = base_type ("11") + this_instance ("+2")
	absorption = base_type ("3") + this_instance ("+0")

To-hit:
	1d20 + accuracy >= evasion

To-wound:
	max(damage_roll - absorption, 1)

## Concepts and Ideas

	Color-based effects or biomes that only have an impact when in the FOV?
	The "obscurity" is a random value set at the beginning of a run, and lost upon death. The game will have various secrets, some of which are only accessible via certain obscurity values.
	A banana taped to a wall?
	A note taped to a wall that says "I. O. U. 1 Banana"
	Could also have an art gallery room
	"Dead Souls" - Each time you die, your past souls are collected, and you might be able to spend them to unlock something new.
	A lock in one dimension needs a key (password) in another?
	It could be interesting, not necssarily a good or fun idea, but if you had another "point" or currency. Where if you spend the first one you get some kind of "cursed knowledge" point and that affects the run somehow? So the more you use your forbidden knowledge the more weird things get?
    If you use IRL time and date as a mechanic, go big or go home. Maybe the horror dimension is only accessible during full/new moons?
    Should the selected dimension be known at the start of a run?
    More of a certain dungeon feature in some runs i.e. too many fountains run?
	Inventory should show item weights

## Healing Items

	potion of healing / greater healing / full healing
	nano cells (nanophage)
	medical bag " cocane"
	holy crystal
	stim pack
	milk of the poppy
	adrenaline shot
	nectar of the gods "ambrosia"
	eldar brain fluid
	med pack
	mystical fruit or Berry
	whiskey or just booze.

## Melee Weapons

Weapons are present here are common / uncommon - rare / God like - super experimental one of a kind.

	1. sword / club / axe
	2. Blessed / holy Weapons / mater worked / ancestors Weapons ect.
	3. Gift of the gods / tooth of the great dragon / diamond of the deep.

	1. 3d printed weapons / old world rusty / hand me down.
	2. Branded Gucci weapons / Military grade / master Smithed construction.
	3. Mono edge hyper blade / organic deconstruction forged / experimental titanium fusion cutters.

	1. Pocket knife / house tools ( shovel / cricket bat) ect.
	2. Cold forged / silver / rolled and folded metal / combat proven.
	3. Titanium / steam powered / pneumatic / dimond edge /   chrome plated /

	1. Hidden blade  (shoe / wrist) / spike ring / sleep spray.
	2. Tazer / brass knuckles / trippy spray / batton "tonfa".
	3. One of a kind Q experimental weapons. / uranium blade / banned chemical weapons acid spray .

	1. Axe / sword / club
	2. Monster bone / monster blood forged / slayer weapons from ancient times / Blood line inherited weapons.
	3. Gift of the gods / God forged / meteoric metals. Slayed a demi God / used in God war / has shed the blood of gods.

	1. Kitchen knife / tools. Home made defence weapons.
	2. Antique weapons / Exotic poison coated / battle tested.
	3. Tooth of cathulu / esoteric mind sliver /  weapons of the fallen kings of Atlantis.

	1. Combat blade / basic military kit / temu mall ninja gear.
	2. Laser eched weapons / small batch field  test weapons / brand new out of box.
	3. Gauntlets of telk / eye of ra / worm tooth of si Halood.

	1. Bowie knife / tomahawk / native spear / cast iron tools ect.
	2. Spring Steel / cold forged / rattle snake poison / mercury edged /  Reverse Serrated.
	3. Spear of the dream walker / experimental gun blade / blade of the templar / Vatican blessed holy relic.

## Ranged Weapons

Weapons are present here are common / uncommon - rare / God like - super experimental one of a kind.

	1. Bow / cross bow / sling / javelins ect.
	2. Magically enchanted weapons and or ammunition / holy / master worked / Ancestors.
	3. Gift of the gods. Dragon fire bow / soul eater crossbow / javelins of lightning.

	1. 3d printed guns / rusty old word guns. Jerry rigged.
	2. Branded Gucci guns / Military grade / bespoke special editions / specifically designed ammo (armour piecing / hollow point ect.)
	3. Tesla hyper beam cannon / experimental thematic manipulation ray / gravidic conversion stream / anti reality fabric hacker / spontaneous combustion field / magnetic ion atom smasher.

	1. Common crystal construction / home made / fragile.
	2. Antique construction of past generations / sturdy construction / multiple firing chambers / more exotic and rare earth minerals.
	3. Pure untarnished faultless crystal or gem construction / soul gem that contains ally or enemy soul / pure unstable quantum core power supply.

	1. Crude / poor construction / simple blow guns and projectiles.
	2. Old world weapons / new condition or recently recovered / mint condition or cannibalised guns rifles ect. Specially designed ammunition.
	3. Pre war experimental weapons (see cyberpunk)

	1. Standard pistol / hidden dart / watch laser ( low power)
	2. Military grade pistol / shotgun / machine gun / well maintained / polished / laser watch (med power)
	3. One of a kind Q weapons / Anti material rife with special ammunition. / multi barrel rocket launcher with programed ammunition. Laser watch (high)

	1. Ref: 1 standard fantasy with Greek twist. Eg.
	2. Falcata (sword)
	3. Javelins of zues. Club of hercules ect.

	1. Old / rusty / poor construction / poorly maintained - fire arms.
	2. Well maintained / military grade / new / perfect condition / blessed elephant gun / Tommy gun / crank handle gattling gun.
	3. Elder brain warp crystal ammunition / elder God touched ray gun / liminal reality beam conducton array /Finger of unsherlubb' the deep one.

	1. Old / dirty / early generation firearms
	2. Standard military grade / extra magazine / upgrades (sites / pistol grip / optics) spec ammo / extended magazine.
	3. Cutting edge technology / one of a kind experimental weapons/ goa 'uld serpent pistol "zat" (pair / duel ) staff of light (moct toe)

	Heavy moct toe (requires tripod of very high strength)

	1. Ref: 1 Standard fantasy.

	1. Old / rusty / poor construction / poorly maintained - fire arms.
	2. Well maintained / military grade / new / perfect condition / blessed/ repeating / blessed tomahawk  / crank handle gattling gun.
	3. Vatican relic / totem of the tribe / man portable cannon with special ammunition.

## Armour

	1. Leather / light / natural.
	2. Medium / metal / chain.
	3. Full plate / dragon hide / God touched.

	1. Stab resist / metal / last generation.
	2. Bullet resistant / Stab proof / ceramic plate / Gucci brand.
	3. Sub dermal nano plates / white platelet turbo generator / lizard DNA regeneration injection / kenetic absorption and focal tech.

	1. Leather / flawed crystal construction / battle damaged / silk mix.
	2. Pure silk / Exotic rare crystal construction / master crafted.
	3. Amulet of the core mother / light shield energy projector for the fall / sentient orb of protection (sep)

	1. Rusty / old / poor construction.
	2. Pre war / military grade / mint condition.
	3. Power armour / stealth suit / Tesla lighting attraction plate.

	See 1 generic fantasy.

	1. Stab resist / metal / last generation.
	2. Bullet resistant / Stab proof / ceramic plate / Gucci brand.
	3. One of a kind Q armour / watch of bullet reputation / attraction / " golden eye" EMP emitter.

	1. Leather / light / natural.
	2. Medium / metal / bronze.
	3. Zues blessed / shield of reflection / lion of nemmedia cloak.

	1. 1. Leather / light / natural. Silk mix.
	2. Medium / metal / pure silk.
	3. Full plate heirloom construct / Amulet of otrallort / slime of the elder beast / mirror of the ever changing staircase.

## Narrative Goals

	1. Defeat villian / kill all x in area.
	2. Collection of item(s)
	3. Activation or deactivate  grid / power supply / ritual.

